<template>
<div>
  <st-search
    md="12"
    text="Buscar por nombre o código"
    @enter="searchTutor($event)"
  />
  <st-select-table
    :dataInfo="{ headers, items , key}"
    :loading="loading"
    @selected="captureTutor($event)"
  />
  <div class="items-box"> <!-- esto podria ser un componente -->
      <div v-for="(tutor,index) in tutors" :key="tutor.codigo">
          <v-btn color="primary" small text @click="deleteTutor(index)">X</v-btn>
          {{ tutor.nombres }}
      </div>
  </div>
  <div class="content-footer">
    <st-secondary-btn nombre="Cancelar" @click="$emit('cancel')"/>
    <st-primary-btn nombre="Siguiente" @click="goNext()" />
  </div>
</div>
</template>

<script>
import Search from '@/components/Search'
import SelectTable from '@/components/SelectTable'

export default {
  data () {
    return{
      tutors:[],
      loading: false,
      key: 'id_tutor',
      items:[],
      headers: [
        {
          text:'Nombre',
          align: 'start',
          value:'nombres',
        },
        {
          text:'Código',
          value:'codigo',
        },
      ],
    }
  },
  components:{
    'st-search': Search,
    'st-select-table': SelectTable,
  },
  methods: {
    goNext(){
      let data = this.tutors.map((tutor) => tutor.idTutor)
      this.$emit('next',{ tutores: data })
    },
    async searchTutor(value){
      this.loading = true
      try{
        let { data: { data }} = await this.$api.getTutors(this.$store.state.role.idUnit,value)
        this.items = data
      } catch(e){
        this.$store.commit('setError', e)
      }
      this.loading = false
    },
    captureTutor(tutor){
      let st = this.tutors.filter((obj) => obj.idTutor == tutor.id_tutor)
       if (st.length == 0) this.tutors.push({idTutor:tutor.id_tutor, nombres:tutor.nombres})
    },
    deleteTutor(index){
      this.tutors.splice(index,1)
    },
  },
  computed:{
    valid(){
      return this.tutors.length !== 0
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
